//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * アザリナ攻撃状態実装
 * @author Junpee
 */

#include "Core/Utility/stdafx.h"
#include "Enemy/Azalinna/AzalinnaAttackState.h"
#include "Game/Sound/SoundSystem.h"
#include "Enemy/System/Enemy.h"
#include "Stage/System/Stage.h"

#include "Enemy/Azalinna/AzalinnaStandState.h"

//------------------------------------------------------------------------------
// 生成、破棄
//------------------------------------------------------------------------------
// コンストラクタ
AzalinnaAttackState::AzalinnaAttackState(Azalinna* gelaim) : AzalinnaState(gelaim){
}
//------------------------------------------------------------------------------
// デストラクタ
AzalinnaAttackState::~AzalinnaAttackState(){
}
//------------------------------------------------------------------------------
// 実行
//------------------------------------------------------------------------------
// 初期化
void AzalinnaAttackState::initialize(){
	// アニメーションシーケンス設定
	getAnimation()->setSequence(1);
}
//------------------------------------------------------------------------------
// 後始末
void AzalinnaAttackState::finalize(){
	// コリジョンを無効に戻す
	getAttackCollision()->setEnabled(false);
}
//------------------------------------------------------------------------------
// 実行
void AzalinnaAttackState::run(){
	// 定数
	float animationScale = 1.f;
	float moveXZScale = 0.01f;

	// ステート変更
	if(!isDamaged()){
		if(getRunCounter() == 90){
			getEnemy()->setState(new AzalinnaStandState(getAzalinna()));
		}
	}

	// 位置と速度の計算
	calcVelocityAndPosition();
	// 向きの設定
	setDirection(getPlayerDirection());

	// 地形コリジョン
	landCollide();

	// 描画セットアップ
	drawSetup(animationScale);

	// 攻撃
	if(getRunCounter() == 50){
		// 攻撃音を鳴らす
		getSoundSystem()->play("AzalinnaAttack");
		getAttackCollision()->setEnabled(true);
	}
	if(getRunCounter() == 80){ getAttackCollision()->setEnabled(false); }
	if(getAttackCollision()->isEnabled()){
		attackCollide(getAttackBone(), Vector3(0.f, -7.5f, 7.5f), 7.5f, 70);
	}

}
//------------------------------------------------------------------------------
